network: example_network

node_params: &node_params
  INCLUDE: !include abstract_sim_params.yaml
  num_parallel_links: 1

node: &node
  type: abstract_node
  properties:
    end_node: False
    num_positions: 2
    port_names:
      - A  # classical communication A side
      - B  # classical communication B side
      - ENT_A  # entanglement generation A side
      - ENT_B  # entanglement generation B side
    <<: *node_params

ent_connection_properties: &ent_connection_properties
  dark_count_probability: 0

components:

  start_node:
    type: abstract_node
    properties:
      end_node: True
      port_names:
        - B
        - ENT_B
      num_positions: 1
      <<: *node_params

  ent_connection_1:
    type: mid_heralded_connection
    properties:
      length: 30
      <<: *ent_connection_properties

    connect_to:
      node1: start_node
      node2: repeater_1
      port_name_node1: ENT_B
      port_name_node2: ENT_A
      label: entanglement_connection

  cl_connection_1:
    type: classical_connection
    properties:
      length: 30
    connect_to:
      node1: start_node
      node2: repeater_1
      port_name_node1: B
      port_name_node2: A
      label: classical_connection

  repeater_1:
    <<: *node

  ent_connection_2:
    type: mid_heralded_connection
    properties:
      length: 30
      <<: *ent_connection_properties
    connect_to:
      node1: repeater_1
      node2: repeater_2
      port_name_node1: ENT_B
      port_name_node2: ENT_A
      label: entanglement_connection

  cl_connection_2:
    type: classical_connection
    properties:
      length: 30
    connect_to:
      node1: repeater_1
      node2: repeater_2
      port_name_node1: B
      port_name_node2: A
      label: classical_connection

  repeater_2:
    <<: *node

  ent_connection_3:
    type: mid_heralded_connection
    properties:
      length: 30
      <<: *ent_connection_properties
    connect_to:
      node1: repeater_2
      node2: end_node
      port_name_node1: ENT_B
      port_name_node2: ENT_A
      label: entanglement_connection

  cl_connection_3:
    type: classical_connection
    properties:
      length: 30
    connect_to:
      node1: repeater_2
      node2: end_node
      port_name_node1: B
      port_name_node2: A
      label: classical_connection

  end_node:
    type: abstract_node
    properties:
      end_node: True
      port_names:
        - A
        - ENT_A
      num_positions: 1
      <<: *node_params
